function make_pow_normal(n)
  return function(x)
    local y = 1
    for i = 1, n do
      y = y * x
    end
    return y
  end
end

function make_pow_meta(n)
  local s = "return function(x) return "
  for i = 1, n do
    s = s .. "x*"
  end
  s = s .. "1 end"
  return loadstring(s)()
end

local bench = function(f, name)
  local pow2 = f(50)
  local start = os.clock()
  for i = 1, 10000 do
    pow2(2)
  end
  print(name, os.clock() - start)
end

bench(make_pow_normal, 'normal')
bench(make_pow_meta, 'meta')
