macro_rules! do_twice {
    ($s:stmt) => {
        $s;
        $s;
    }
}

macro_rules! my_println {
    () => (print!("\n"));
    ($fmt:expr) => (print!(concat!($fmt, "\n")));
    ($fmt:expr, $($arg:tt)*) => (print!(concat!($fmt, "\n"), $($arg)*));
}

#[allow(unused_variables)]
fn consume(s: String) {}

fn do_twice<F: Fn() -> ()>(f: F) {
    f();
    f();
}

fn main() {
    do_twice!({
        println!("Hello!");
    });

    let s = "Hello".to_string();
    do_twice!({
        consume(s);
        println!("s is consumed");
    });
    // do_twice(move || {
    //     consume(s);
    //     println!("s is consumed");
    // });
}
